/*

<Aicaca Community Messenger Server>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.Threading;
using System.ComponentModel;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace TalkServer
{
	public class WinAccept
	{
		private WinCom WC = new WinCom();
		private WinServer xWinServer;
        private WinBoard xWinBoard = new WinBoard();

		private Socket ServerSocket = null;
		private string rootID;

		public WinAccept(WinServer tWinServer, string tRootID)
		{
			xWinServer = tWinServer;
			this.rootID = tRootID;
		}

		public void CloseThis()
		{
			if (ServerSocket != null)
			{
				ServerSocket.Close();
                xWinServer.pMainStatus = WC.lineStr3;
				xWinServer.pProcessStatus = "";
			}
		}

		public void ServerProc()
		{
			string rootIP = WC.GetXML(rootID, "ri");
			int rootPort = Convert.ToInt32(WC.GetXML(rootID, "rp"));

			ServerSocket = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);
			ServerSocket.Blocking = true;

			try
			{
				ServerSocket.Bind(new IPEndPoint(IPAddress.Any, rootPort));
				ServerSocket.Listen(-1);

                xWinServer.pMainStatus = WC.lineStr2;
				xWinServer.pProcessStatus = WC.GetXML(rootID, "rn") + ":" + WC.GetXML(rootID, "ri") + ":" + WC.GetXML(rootID, "rp");
			}
			catch (Exception e)
			{
				MessageBox.Show(WC.lineStr1);
				return;
			}

			while (ServerSocket != null) 
			{
				Socket ClientSocket = ServerSocket.Accept();

				if (ClientSocket != null)
				{
					this.StartWinDialog(ClientSocket);
				}
			}

			if (ServerSocket != null)
			{
				ServerSocket.Close();
				ServerSocket = null;
			}
		}

		private void StartWinDialog(Socket sk)
		{
			WinDialog xWinDialog = new WinDialog(xWinServer, xWinBoard, sk, rootID);
			Thread ClientThread = new Thread(new ThreadStart(xWinDialog.ServerProc));
			ClientThread.Start();
		}
	}
}
