/*

<Aicaca Community Messenger Server>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.Xml;
using System.IO;
using System.Data;
using System.Collections;
using System.Windows.Forms;
using System.Runtime.Serialization.Formatters.Binary;
using System.Data.OleDb;

namespace TalkServer
{
	public class WinBoard
	{
        private WinCom WC = new WinCom();
		private WinSearch WS = new WinSearch();

		public byte[] ListProcess(string sort)
		{
			lock(this)
			{
				byte[] sendStream = null;

				if (System.IO.File.Exists(WC.varStr1 + "Data\\" + sort + "_Data.xml"))
				{
					XmlDocument xd = new XmlDocument();
					xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");
					XmlNodeList xnl = xd.SelectNodes("data/record");

					if (xnl.Count > 0)
					{
						MemoryStream stream = new MemoryStream();
						XmlTextWriter xw = new XmlTextWriter(stream, System.Text.Encoding.UTF8);
						xw.WriteStartElement("recordList");
			
						for (IEnumerator ie = xnl.GetEnumerator() ; ie.MoveNext() ;)
						{
							XmlNode xa = ((XmlNode)ie.Current);

							xw.WriteStartElement("record");
							xw.WriteElementString("recordID", xa.SelectSingleNode("recordID").InnerText);
							xw.WriteElementString("step", xa.SelectSingleNode("step").InnerText);
							xw.WriteElementString("title", xa.SelectSingleNode("title").InnerText);
							xw.WriteElementString("writer", xa.SelectSingleNode("writer").InnerText);
							xw.WriteElementString("email", xa.SelectSingleNode("email").InnerText);
							xw.WriteElementString("upload", xa.SelectSingleNode("upload").InnerText);
							xw.WriteElementString("hit", xa.SelectSingleNode("hit").InnerText);
							xw.WriteElementString("createdDate", xa.SelectSingleNode("createdDate").InnerText);
							xw.WriteEndElement();
						}

						xw.WriteEndElement();
						xw.Flush();
						xw.Close();

						sendStream = stream.ToArray();
					}
				}

				return sendStream;
			}
		}

		public byte[] MsgProcess(string sort, string currentID)
		{
			lock(this)
			{
				byte[] sendStream = null;

				XmlDocument xd = new XmlDocument();
				xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");
				XmlNode xn = xd.SelectSingleNode("data/record[recordID='" + currentID + "']");

				string recordID = xn.SelectSingleNode("recordID").InnerText;
				string title = xn.SelectSingleNode("title").InnerText;
				string writer = xn.SelectSingleNode("writer").InnerText;
				string email = xn.SelectSingleNode("email").InnerText;
				string msg = WS.GetMsg(sort, Convert.ToInt32(xn.SelectSingleNode("msg").InnerText));
				string pwd = xn.SelectSingleNode("pwd").InnerText;
				string upload = xn.SelectSingleNode("upload").InnerText;

				MemoryStream stream = new MemoryStream();
				XmlTextWriter xw = new XmlTextWriter(stream, System.Text.Encoding.UTF8);

				xw.WriteStartElement("record");
				xw.WriteElementString("recordID", recordID);
				xw.WriteElementString("title", title);
				xw.WriteElementString("writer", writer);
				xw.WriteElementString("email", email);
				xw.WriteElementString("msg", msg);
				xw.WriteElementString("pwd", pwd);
				xw.WriteElementString("upload", upload);
				xw.WriteEndElement();
				xw.Flush();
				xw.Close();

				sendStream = stream.ToArray();

				XmlNode xh1 = xn.SelectSingleNode("hit");
				int nextHit = Convert.ToInt32(xh1.InnerText) + 1;
				XmlElement xh2 = xd.CreateElement("hit");
				XmlText xh2_t = xd.CreateTextNode(nextHit.ToString());
				xh2.AppendChild(xh2_t);
				xn.ReplaceChild(xh2, xh1);

				xd.Save(WC.varStr1 + "Data\\" + sort + "_Data.xml");

				return sendStream;
			}
		}

		public void SaveProcess(string sort, byte[] getStream, string uploadFile)
		{
			lock(this)
			{
				this.CheckFiles(sort);

				XmlDocument dd = new XmlDocument();
				dd.Load(new MemoryStream(getStream));

				string idStr = this.GetRecordID(sort);
				string titleStr = dd.SelectSingleNode("record/title").InnerText;
				string writerStr = dd.SelectSingleNode("record/writer").InnerText;
				string emailStr = dd.SelectSingleNode("record/email").InnerText;
				string msgStr = dd.SelectSingleNode("record/msg").InnerText;
				string pwdStr = dd.SelectSingleNode("record/pwd").InnerText;
				string uploadStr = uploadFile;
				string ipStr = dd.SelectSingleNode("record/remoteIP").InnerText;
				string dateStr = DateTime.Now.ToShortDateString() + " : " + DateTime.Now.ToShortTimeString();

				msgStr = WS.SaveProcess(sort, msgStr);

				XmlDocument xd = new XmlDocument();
				xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");

				XmlElement record = xd.CreateElement("record");
				XmlElement recordID = xd.CreateElement("recordID");
				XmlElement step = xd.CreateElement("step");
				XmlElement title = xd.CreateElement("title");
				XmlElement writer = xd.CreateElement("writer");
				XmlElement email = xd.CreateElement("email");
				XmlElement msg = xd.CreateElement("msg");
				XmlElement pwd = xd.CreateElement("pwd");
				XmlElement upload = xd.CreateElement("upload");
				XmlElement hit = xd.CreateElement("hit");
				XmlElement createdDate = xd.CreateElement("createdDate");
				XmlElement remoteIP = xd.CreateElement("remoteIP");

				XmlText recordID_t = xd.CreateTextNode(idStr);
				XmlText step_t = xd.CreateTextNode("1");
				XmlText title_t = xd.CreateTextNode(titleStr);
				XmlText writer_t = xd.CreateTextNode(writerStr);
				XmlText email_t = xd.CreateTextNode(emailStr);
				XmlText msg_t = xd.CreateTextNode(msgStr);
				XmlText pwd_t = xd.CreateTextNode(pwdStr);
				XmlText upload_t = xd.CreateTextNode(uploadStr);
				XmlText hit_t = xd.CreateTextNode("1");
				XmlText createdDate_t = xd.CreateTextNode(dateStr);
				XmlText remoteIP_t = xd.CreateTextNode(ipStr);
			
				record.AppendChild(recordID);
				record.AppendChild(step);
				record.AppendChild(title);
				record.AppendChild(writer);
				record.AppendChild(email);
				record.AppendChild(msg);
				record.AppendChild(pwd);
				record.AppendChild(upload);
				record.AppendChild(hit);
				record.AppendChild(createdDate);
				record.AppendChild(remoteIP);

				recordID.AppendChild(recordID_t);
				step.AppendChild(step_t);
				title.AppendChild(title_t);
				writer.AppendChild(writer_t);
				email.AppendChild(email_t);
				msg.AppendChild(msg_t);
				pwd.AppendChild(pwd_t);
				upload.AppendChild(upload_t);
				hit.AppendChild(hit_t);
				createdDate.AppendChild(createdDate_t);
				remoteIP.AppendChild(remoteIP_t);

				XmlNode xb = xd.DocumentElement.FirstChild;
            
				if (xb != null)
				{
					xd.DocumentElement.InsertBefore(record, xb);
				}
				else
				{
					xd.DocumentElement.AppendChild(record);
				}

				xd.Save(WC.varStr1 + "Data\\" + sort + "_Data.xml");
			}
		}

		public void DeleteProcess(string sort, string currentID)
		{
			lock(this)
			{
				XmlDocument xd = new XmlDocument();
				xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");

				XmlNode xn = xd.SelectSingleNode("data/record[recordID='" + currentID + "']");
				int pos = Convert.ToInt32(xn.SelectSingleNode("msg").InnerText);
				xn.ParentNode.RemoveChild(xn);
				xd.Save(WC.varStr1 + "Data\\" + sort + "_Data.xml");

				WS.DeleteProcess(sort, pos);
			}
		}

		public void ReplyProcess(string sort, string currentID, byte[] getStream, string uploadFile)
		{
			lock(this)
			{
				XmlDocument dd = new XmlDocument();
				dd.Load(new MemoryStream(getStream));

				string idStr = this.GetRecordID(sort);
				string titleStr = dd.SelectSingleNode("record/title").InnerText;
				string writerStr = dd.SelectSingleNode("record/writer").InnerText;
				string emailStr = dd.SelectSingleNode("record/email").InnerText;
				string msgStr = dd.SelectSingleNode("record/msg").InnerText;
				string pwdStr = dd.SelectSingleNode("record/pwd").InnerText;
				string uploadStr = uploadFile;
				string ipStr = dd.SelectSingleNode("record/remoteIP").InnerText;
				string dateStr = DateTime.Now.ToShortDateString() + " : " + DateTime.Now.ToShortTimeString();

				msgStr = WS.SaveProcess(sort, msgStr);

				XmlDocument xd = new XmlDocument();
				xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");

				XmlNode xn1 = xd.SelectSingleNode("data/record[recordID='" + currentID + "']");

				int originStep = Convert.ToInt32(xn1.SelectSingleNode("step").InnerText);
				int nextStep = originStep + 1;
				string stepStr = nextStep.ToString();

				XmlElement xn2 = xd.CreateElement("record");
				XmlElement recordID = xd.CreateElement("recordID");
				XmlElement step = xd.CreateElement("step");
				XmlElement title = xd.CreateElement("title");
				XmlElement writer = xd.CreateElement("writer");
				XmlElement email = xd.CreateElement("email");
				XmlElement msg = xd.CreateElement("msg");
				XmlElement pwd = xd.CreateElement("pwd");
				XmlElement upload = xd.CreateElement("upload");
				XmlElement hit = xd.CreateElement("hit");
				XmlElement createdDate = xd.CreateElement("createdDate");
				XmlElement remoteIP = xd.CreateElement("remoteIP");

				XmlText recordID_t = xd.CreateTextNode(idStr);
				XmlText step_t = xd.CreateTextNode(stepStr);
				XmlText title_t = xd.CreateTextNode(titleStr);
				XmlText writer_t = xd.CreateTextNode(writerStr);
				XmlText email_t = xd.CreateTextNode(emailStr);
				XmlText msg_t = xd.CreateTextNode(msgStr);
				XmlText pwd_t = xd.CreateTextNode(pwdStr);
				XmlText upload_t = xd.CreateTextNode(uploadStr);
				XmlText hit_t = xd.CreateTextNode("1");
				XmlText createdDate_t = xd.CreateTextNode(dateStr);
				XmlText remoteIP_t = xd.CreateTextNode(ipStr);
			
				xn2.AppendChild(recordID);
				xn2.AppendChild(step);
				xn2.AppendChild(title);
				xn2.AppendChild(writer);
				xn2.AppendChild(email);
				xn2.AppendChild(msg);
				xn2.AppendChild(pwd);
				xn2.AppendChild(upload);
				xn2.AppendChild(hit);
				xn2.AppendChild(createdDate);
				xn2.AppendChild(remoteIP);

				recordID.AppendChild(recordID_t);
				step.AppendChild(step_t);
				title.AppendChild(title_t);
				writer.AppendChild(writer_t);
				email.AppendChild(email_t);
				msg.AppendChild(msg_t);
				pwd.AppendChild(pwd_t);
				upload.AppendChild(upload_t);
				hit.AppendChild(hit_t);
				createdDate.AppendChild(createdDate_t);
				remoteIP.AppendChild(remoteIP_t);

				xn1.ParentNode.InsertAfter(xn2, xn1);
				xd.Save(WC.varStr1 + "Data\\" + sort + "_Data.xml");
			}
		}

		public void ModifyProcess(string sort, string currentID, byte[] getStream)
		{
			lock(this)
			{
				XmlDocument dd = new XmlDocument();
				dd.Load(new MemoryStream(getStream));

				string idStr = currentID;
				string titleStr = dd.SelectSingleNode("record/title").InnerText;
				string writerStr = dd.SelectSingleNode("record/writer").InnerText;
				string emailStr = dd.SelectSingleNode("record/email").InnerText;
				string msgStr = dd.SelectSingleNode("record/msg").InnerText;
				string pwdStr = dd.SelectSingleNode("record/pwd").InnerText;
				string ipStr = dd.SelectSingleNode("record/remoteIP").InnerText;
				string dateStr = DateTime.Now.ToShortDateString() + " : " + DateTime.Now.ToShortTimeString();

				XmlDocument xd = new XmlDocument();
				xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");

				XmlNode xn1 = xd.SelectSingleNode("data/record[recordID='" + idStr + "']");
				WS.DeleteProcess(sort, Convert.ToInt32(xn1.SelectSingleNode("msg").InnerText));
				msgStr = WS.SaveProcess(sort, msgStr);

				XmlElement xn2 = xd.CreateElement("record");
				XmlElement recordID = xd.CreateElement("recordID");
				XmlElement step = xd.CreateElement("step");
				XmlElement title = xd.CreateElement("title");
				XmlElement writer = xd.CreateElement("writer");
				XmlElement email = xd.CreateElement("email");
				XmlElement msg = xd.CreateElement("msg");
				XmlElement pwd = xd.CreateElement("pwd");
				XmlElement upload = xd.CreateElement("upload");
				XmlElement hit = xd.CreateElement("hit");
				XmlElement createdDate = xd.CreateElement("createdDate");
				XmlElement remoteIP = xd.CreateElement("remoteIP");

				XmlText recordID_t = xd.CreateTextNode(idStr);
				XmlText step_t = xd.CreateTextNode(xn1.SelectSingleNode("step").InnerText);
				XmlText title_t = xd.CreateTextNode(titleStr);
				XmlText writer_t = xd.CreateTextNode(writerStr);
				XmlText email_t = xd.CreateTextNode(emailStr);
				XmlText msg_t = xd.CreateTextNode(msgStr);
				XmlText pwd_t = xd.CreateTextNode(pwdStr);
				XmlText upload_t = xd.CreateTextNode(xn1.SelectSingleNode("upload").InnerText);
				XmlText hit_t = xd.CreateTextNode(xn1.SelectSingleNode("hit").InnerText);
				XmlText createdDate_t = xd.CreateTextNode(dateStr);
				XmlText remoteIP_t = xd.CreateTextNode(ipStr);
			
				xn2.AppendChild(recordID);
				xn2.AppendChild(step);
				xn2.AppendChild(title);
				xn2.AppendChild(writer);
				xn2.AppendChild(email);
				xn2.AppendChild(msg);
				xn2.AppendChild(pwd);
				xn2.AppendChild(upload);
				xn2.AppendChild(hit);
				xn2.AppendChild(createdDate);
				xn2.AppendChild(remoteIP);

				recordID.AppendChild(recordID_t);
				step.AppendChild(step_t);
				title.AppendChild(title_t);
				writer.AppendChild(writer_t);
				email.AppendChild(email_t);
				msg.AppendChild(msg_t);
				pwd.AppendChild(pwd_t);
				upload.AppendChild(upload_t);
				hit.AppendChild(hit_t);
				createdDate.AppendChild(createdDate_t);
				remoteIP.AppendChild(remoteIP_t);

				xn1.ParentNode.ReplaceChild(xn2, xn1);
				xd.Save(WC.varStr1 + "Data\\" + sort + "_Data.xml");
			}
		}

		public byte[] SearchProcess(string sort, string type, string keyword)
		{
			lock(this)
			{
				byte[] sendStream = null;

				if (type != "msg")
				{
					XmlDocument xd = new XmlDocument();
					xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");
					XmlNodeList xnl = xd.SelectNodes("data/record[contains(" + type + ",'" + keyword + "')]");

					if (xnl.Count > 0)
					{
						MemoryStream stream = new MemoryStream();
						XmlTextWriter xw = new XmlTextWriter(stream, System.Text.Encoding.UTF8);
						xw.WriteStartElement("recordList");
			
						for (IEnumerator ie = xnl.GetEnumerator() ; ie.MoveNext() ;)
						{
							XmlNode xa = ((XmlNode)ie.Current);

							xw.WriteStartElement("record");
							xw.WriteElementString("recordID", xa.SelectSingleNode("recordID").InnerText);
							xw.WriteElementString("step", xa.SelectSingleNode("step").InnerText);
							xw.WriteElementString("title", xa.SelectSingleNode("title").InnerText);
							xw.WriteElementString("writer", xa.SelectSingleNode("writer").InnerText);
							xw.WriteElementString("email", xa.SelectSingleNode("email").InnerText);
							xw.WriteElementString("upload", xa.SelectSingleNode("upload").InnerText);
							xw.WriteElementString("hit", xa.SelectSingleNode("hit").InnerText);
							xw.WriteElementString("createdDate", xa.SelectSingleNode("createdDate").InnerText);
							xw.WriteEndElement();
						}

						xw.WriteEndElement();
						xw.Flush();
						xw.Close();

						sendStream = stream.ToArray();
					}
				}
				else
				{
					XmlDocument xd = new XmlDocument();
					xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");
					ArrayList list = WS.SearchProcess(sort, keyword);

					if (list.Count > 0)
					{
						MemoryStream stream = new MemoryStream();
						XmlTextWriter xw = new XmlTextWriter(stream, System.Text.Encoding.UTF8);
						xw.WriteStartElement("recordList");

						for (IEnumerator ie = list.GetEnumerator() ; ie.MoveNext() ;)
						{
							XmlNode xa = xd.SelectSingleNode("data/record[msg='" + ((int)ie.Current).ToString() + "']");

							xw.WriteStartElement("record");
							xw.WriteElementString("recordID", xa.SelectSingleNode("recordID").InnerText);
							xw.WriteElementString("step", xa.SelectSingleNode("step").InnerText);
							xw.WriteElementString("title", xa.SelectSingleNode("title").InnerText);
							xw.WriteElementString("writer", xa.SelectSingleNode("writer").InnerText);
							xw.WriteElementString("email", xa.SelectSingleNode("email").InnerText);
							xw.WriteElementString("upload", xa.SelectSingleNode("upload").InnerText);
							xw.WriteElementString("hit", xa.SelectSingleNode("hit").InnerText);
							xw.WriteElementString("createdDate", xa.SelectSingleNode("createdDate").InnerText);
							xw.WriteEndElement();
						}

						xw.WriteEndElement();
						xw.Flush();
						xw.Close();

						sendStream = stream.ToArray();
					}
				}

				return sendStream;
			}
		}

		private string GetRecordID(string sort)
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "Data\\" + sort + "_Data.xml");

			XmlNode xn1 = xd.SelectSingleNode("data/sequence/recordID");

			if (xn1 != null)
			{
				int originID = Convert.ToInt32(xn1.InnerText);
				int nextID = originID + 1;

				XmlElement xn2 = xd.CreateElement("recordID");
				XmlText xn2_t = xd.CreateTextNode(nextID.ToString());
				xn2.AppendChild(xn2_t);

				xn1.ParentNode.ReplaceChild(xn2, xn1);
				xd.Save(WC.varStr1 + "Data\\" + sort + "_Data.xml");
			
				return originID.ToString();
			}
			else
			{
				XmlElement boardID = xd.CreateElement("recordID");
				XmlText boardID_t = xd.CreateTextNode("2");

				xd.SelectSingleNode("data/sequence").AppendChild(boardID);
				boardID.AppendChild(boardID_t);
				xd.Save(WC.varStr1 + "Data\\" + sort + "_Data.xml");

				return "1";
			}
		}

		private void CheckFiles(string sort)
		{
			if (System.IO.File.Exists(WC.varStr1 + "Data\\" + sort + "_Data.xml") == false)
			{
				XmlTextWriter xw = new XmlTextWriter(WC.varStr1 + "Data\\" + sort + "_Data.xml", null);

				xw.WriteStartElement("data");
				xw.WriteStartElement("sequence");
				xw.WriteEndElement();
				xw.WriteEndElement();
				xw.Flush();
				xw.Close();
			}

			if (System.IO.File.Exists(WC.varStr1 + "Data\\" + sort + "_Index.xml") == false)
			{
				XmlTextWriter xw = new XmlTextWriter(WC.varStr1 + "Data\\" + sort + "_Index.xml", null);
				xw.WriteStartElement("Index");
				xw.WriteElementString("PO", "0");
				xw.WriteEndElement();
				xw.Flush();
				xw.Close();
			}

			if (System.IO.File.Exists(WC.varStr1 + "Data\\" + sort + "_Address.dat") == false)
			{
				FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Address.dat", FileMode.Create, FileAccess.Write);
				StreamWriter sw = new StreamWriter(fs);
				sw.Write("");
				sw.Flush();
				sw.Close();
			}

			if (System.IO.File.Exists(WC.varStr1 + "Data\\" + sort + "_Source.dat") == false)
			{
				FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Source.dat", FileMode.Create, FileAccess.Write);
				StreamWriter sw = new StreamWriter(fs);
				sw.Write("");
				sw.Flush();
				sw.Close();
			}
		}
	}
}
