/*

<Aicaca Community Messenger Server>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;

namespace TalkServer
{
	public class WinCom
	{
        public string varStr1 = "C:\\Program Files\\Aicaca\\AicacaServer1.2\\";

		public string lineStr1 = "Can't use the root port!";
		public string lineStr2 = "Server is running...";
		public string lineStr3 = "Server is stopped...";
		public string lineStr4 = "Can't connect to the client.";
		public string lineStr5 = "There is a problem in processing XML data.";
        public string lineStr6 = "Please input the port number.";
        public string lineStr7 = "Please select a row.";
        public string lineStr8 = "One of the fields is empty.";
		public string lineStr9 = "There is a problem in starting the server.";

		public string RemoveStr(string originStr, string removeStr)
		{
			string rv = "";

			try
			{
				int firstPos = originStr.IndexOf(removeStr);
				int originLen = originStr.Length;
				int removeLen = removeStr.Length;

				if (firstPos >= 0)
				{
					rv = originStr.Substring(0, firstPos) + originStr.Substring(firstPos+removeLen, originLen-firstPos-removeLen);
				}
			}
			catch (Exception e)
			{
				rv = "Error : Aicaca.Com.String.RemoveStr";
			}

			return rv;
		}

		public string ReplaceStr(string originStr, string feedStr, string returnStr)
		{
			string rv = originStr;
			int firstPos = -1;
			int feedLength = feedStr.Length;

			try
			{
				while ((firstPos=rv.IndexOf(feedStr, firstPos+1)) != -1)
				{
					rv = rv.Substring(0, firstPos) + returnStr + rv.Substring(firstPos+feedLength);
				}
			}
			catch (Exception e)
			{
				rv = "Error : Aicaca.Com.String.ReplaceStr";
			}

			return rv;
		}

		public string MakeXML(string tagStr, string valueStr)
		{
			string rv = "";

			rv = "<" + tagStr + ">" + valueStr + "</" + tagStr + ">";

			return rv;
		}

		public string GetXML(string originStr, string tagStr)
		{
			string rv = "";

			try
			{
				int firstPos = originStr.IndexOf("<" + tagStr + ">");
				int secondPos = originStr.IndexOf("</" + tagStr + ">");
				int tagLen = tagStr.Length;

				if (firstPos != -1 && secondPos != -1)
				{
					rv = originStr.Substring(firstPos+tagLen+2, secondPos-firstPos-tagLen-2);
				}
			}

			catch (Exception e)
			{
				rv = "Error : Aicaca.Com.XML.GetXML";
			}

			return rv;
		}

		public string GetXML(string originStr, string tagStr, int pos)
		{
			string rv = "";

			try
			{
				int firstPos = originStr.IndexOf("<" + tagStr + ">", pos);
				int secondPos = originStr.IndexOf("</" + tagStr + ">", pos);
				int tagLen = tagStr.Length;

				if (firstPos != -1 && secondPos != -1)
				{
					rv = originStr.Substring(firstPos+tagLen+2, secondPos-firstPos-tagLen-2);
				}
			}

			catch (Exception e)
			{
				rv = "Error : Aicaca.Com.XML.GetXML";
			}

			return rv;
		}

		public string GetNextXML(string originStr, string tagStr)
		{
			string rv = "";

			try
			{
				int firstPos = originStr.IndexOf("<" + tagStr + ">");
				int originLen = originStr.Length;
				int tagLen = tagStr.Length;

				if (firstPos != -1)
				{
					rv = originStr.Substring(firstPos+tagLen+2, originLen-firstPos-tagLen-2);
				}
			}

			catch (Exception e)
			{
				rv = "Error : Aicaca.Com.XML.GetNextXML";
			}

			return rv;
		}

		public string MakeRootID(string rootSort, string rootName, string rootIP, string rootPort)
		{
			string rv = "";

			rv = "<rid>" + this.MakeXML("rs", rootSort) + this.MakeXML("rn", rootName) + this.MakeXML("ri", rootIP) + this.MakeXML("rp", rootPort) + "</rid>";

			return rv;
		}

		public string MakeLocalID(string localSort, string localName, string localIP, string localPort)
		{
			string rv = "";

			rv = "<lid>" + this.MakeXML("ls", localSort) + this.MakeXML("ln", localName) + this.MakeXML("li", localIP) + this.MakeXML("lp", localPort) + "</lid>";

			return rv;
		}

		public string MakeClientID(string clientSort, string clientName, string clientIP, string clientPort)
		{
			string rv = "";

			rv = "<cid>" + this.MakeXML("cs", clientSort) + this.MakeXML("cn", clientName) + this.MakeXML("ci", clientIP) + this.MakeXML("cp", clientPort) + "</cid>";

			return rv;
		}

		public string MakeThreadID(string threadSort, string threadName, string threadIP, string threadPort)
		{
			string rv = "";

			rv = "<tid>" + this.MakeXML("ts", threadSort) + this.MakeXML("tn", threadName) + this.MakeXML("ti", threadIP) + this.MakeXML("tp", threadPort) + "</tid>";

			return rv;
		}

		public string MakeRemoteID(string remoteSort, string remoteName, string remoteIP, string remotePort)
		{
			string rv = "";

			rv = "<eid>" + this.MakeXML("es", remoteSort) + this.MakeXML("en", remoteName) + this.MakeXML("ei", remoteIP) + this.MakeXML("ep", remotePort) + "</eid>";

			return rv;
		}

		public string LocalToClient(string localID)
		{
			string rv = "";

			string clientSort = this.GetXML(localID, "ls");
			string clientName = this.GetXML(localID, "ln");
			string clientIP = this.GetXML(localID, "li");
			string clientPort = this.GetXML(localID, "lp");

			rv = this.MakeClientID(clientSort, clientName, clientIP, clientPort);

			return rv;
		}

		public string ClientToLocal(string clientID)
		{
			string rv = "";

			string localSort = this.GetXML(clientID, "cs");
			string localName = this.GetXML(clientID, "cn");
			string localIP = this.GetXML(clientID, "ci");
			string localPort = this.GetXML(clientID, "cp");

			rv = this.MakeLocalID(localSort, localName, localIP, localPort);

			return rv;
		}

		public string ThreadToRemote(string threadID)
		{
			string rv = "";

			string remoteSort = this.GetXML(threadID, "ts");
			string remoteName = this.GetXML(threadID, "tn");
			string remoteIP = this.GetXML(threadID, "ti");
			string remotePort = this.GetXML(threadID, "tp");

			rv = this.MakeRemoteID(remoteSort, remoteName, remoteIP, remotePort);

			return rv;
		}

		public string RemoteToThread(string remoteID)
		{
			string rv = "";

			string threadSort = this.GetXML(remoteID, "es");
			string threadName = this.GetXML(remoteID, "en");
			string threadIP = this.GetXML(remoteID, "ei");
			string threadPort = this.GetXML(remoteID, "ep");

			rv = this.MakeThreadID(threadSort, threadName, threadIP, threadPort);

			return rv;
		}
	}
}
