/*

<Aicaca Community Messenger Server>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Net;
using System.Xml;
using System.Data;

namespace TalkServer
{
    public class WinConfig : System.Windows.Forms.Form
    {
        private WinCom WC = new WinCom();
        private WinServer xWinServer = null;

        private DataTable xDataTable = new DataTable("boardList");
		private int selRow = -1;
		private System.Windows.Forms.Button addButton;
		private System.Windows.Forms.Button removeButton;
		private System.Windows.Forms.DataGrid boardGrid;
		private System.Windows.Forms.DataGridTableStyle boardTableStyle;
		private System.Windows.Forms.DataGridTextBoxColumn typeStyle;
		private System.Windows.Forms.DataGridTextBoxColumn nameStyle;
		private System.Windows.Forms.Button saveButton;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.DataGridTextBoxColumn passwordStyle;
		private System.Windows.Forms.Button editButton;
		private System.Windows.Forms.TextBox portBox;
		private System.Windows.Forms.TextBox versionBox;
		private System.Windows.Forms.Label versionLabel;
		private System.Windows.Forms.Label portLabel;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage mainTap;
		private System.Windows.Forms.TabPage boardTap;
		private System.Windows.Forms.DataGridTextBoxColumn idStyle;

        public WinConfig(WinServer tWinServer)
        {
            xWinServer = tWinServer;

            this.InitializeComponent();
            this.ReadConfig();
			this.ShowDialog();
        }

        #region Windows Form Designer generated code
        private void InitializeComponent()
		{
			this.removeButton = new System.Windows.Forms.Button();
			this.boardTableStyle = new System.Windows.Forms.DataGridTableStyle();
			this.boardGrid = new System.Windows.Forms.DataGrid();
			this.idStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.nameStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.typeStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.passwordStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.editButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.addButton = new System.Windows.Forms.Button();
			this.saveButton = new System.Windows.Forms.Button();
			this.portBox = new System.Windows.Forms.TextBox();
			this.versionBox = new System.Windows.Forms.TextBox();
			this.versionLabel = new System.Windows.Forms.Label();
			this.portLabel = new System.Windows.Forms.Label();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.tabControl = new System.Windows.Forms.TabControl();
			this.mainTap = new System.Windows.Forms.TabPage();
			this.boardTap = new System.Windows.Forms.TabPage();
			((System.ComponentModel.ISupportInitialize)(this.boardGrid)).BeginInit();
			this.tabControl.SuspendLayout();
			this.mainTap.SuspendLayout();
			this.boardTap.SuspendLayout();
			this.SuspendLayout();
			// 
			// removeButton
			// 
			this.removeButton.Location = new System.Drawing.Point(232, 8);
			this.removeButton.Name = "removeButton";
			this.removeButton.Size = new System.Drawing.Size(64, 24);
			this.removeButton.TabIndex = 5;
			this.removeButton.Text = "Remove";
			this.removeButton.Click += new System.EventHandler(this.removeButton_Click);
			// 
			// boardTableStyle
			// 
			this.boardTableStyle.DataGrid = this.boardGrid;
			this.boardTableStyle.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
																											  this.idStyle,
																											  this.nameStyle,
																											  this.typeStyle,
																											  this.passwordStyle});
			this.boardTableStyle.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.boardTableStyle.MappingName = "boardList";
			this.boardTableStyle.RowHeadersVisible = false;
			// 
			// boardGrid
			// 
			this.boardGrid.CaptionVisible = false;
			this.boardGrid.DataMember = "";
			this.boardGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.boardGrid.Location = new System.Drawing.Point(8, 40);
			this.boardGrid.Name = "boardGrid";
			this.boardGrid.ReadOnly = true;
			this.boardGrid.Size = new System.Drawing.Size(288, 152);
			this.boardGrid.TabIndex = 0;
			this.boardGrid.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
																								  this.boardTableStyle});
			this.boardGrid.MouseDown += new System.Windows.Forms.MouseEventHandler(this.boardGrid_Click);
			// 
			// idStyle
			// 
			this.idStyle.Format = "";
			this.idStyle.FormatInfo = null;
			this.idStyle.HeaderText = "ID";
			this.idStyle.MappingName = "boardID";
			this.idStyle.Width = 50;
			// 
			// nameStyle
			// 
			this.nameStyle.Format = "";
			this.nameStyle.FormatInfo = null;
			this.nameStyle.HeaderText = "Name";
			this.nameStyle.MappingName = "boardName";
			this.nameStyle.Width = 75;
			// 
			// typeStyle
			// 
			this.typeStyle.Format = "";
			this.typeStyle.FormatInfo = null;
			this.typeStyle.HeaderText = "Type";
			this.typeStyle.MappingName = "boardType";
			this.typeStyle.Width = 75;
			// 
			// passwordStyle
			// 
			this.passwordStyle.Format = "";
			this.passwordStyle.FormatInfo = null;
			this.passwordStyle.HeaderText = "Password";
			this.passwordStyle.MappingName = "boardPassword";
			this.passwordStyle.Width = 75;
			// 
			// editButton
			// 
			this.editButton.Location = new System.Drawing.Point(160, 8);
			this.editButton.Name = "editButton";
			this.editButton.Size = new System.Drawing.Size(64, 24);
			this.editButton.TabIndex = 4;
			this.editButton.Text = "Edit";
			this.editButton.Click += new System.EventHandler(this.editButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(232, 240);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.Size = new System.Drawing.Size(88, 23);
			this.cancelButton.TabIndex = 7;
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// addButton
			// 
			this.addButton.Location = new System.Drawing.Point(88, 8);
			this.addButton.Name = "addButton";
			this.addButton.Size = new System.Drawing.Size(64, 24);
			this.addButton.TabIndex = 3;
			this.addButton.Text = "Add";
			this.addButton.Click += new System.EventHandler(this.addButton_Click);
			// 
			// saveButton
			// 
			this.saveButton.Location = new System.Drawing.Point(136, 240);
			this.saveButton.Name = "saveButton";
			this.saveButton.Size = new System.Drawing.Size(88, 23);
			this.saveButton.TabIndex = 6;
			this.saveButton.Text = "Save";
			this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
			// 
			// portBox
			// 
			this.portBox.Location = new System.Drawing.Point(104, 16);
			this.portBox.MaxLength = 10;
			this.portBox.Name = "portBox";
			this.portBox.Size = new System.Drawing.Size(128, 21);
			this.portBox.TabIndex = 1;
			this.portBox.Text = "";
			// 
			// versionBox
			// 
			this.versionBox.Location = new System.Drawing.Point(104, 48);
			this.versionBox.MaxLength = 100;
			this.versionBox.Name = "versionBox";
			this.versionBox.Size = new System.Drawing.Size(128, 21);
			this.versionBox.TabIndex = 2;
			this.versionBox.Text = "";
			// 
			// versionLabel
			// 
			this.versionLabel.Location = new System.Drawing.Point(8, 56);
			this.versionLabel.Name = "versionLabel";
			this.versionLabel.Size = new System.Drawing.Size(88, 16);
			this.versionLabel.TabIndex = 0;
			this.versionLabel.Text = "Client Version";
			this.versionLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// portLabel
			// 
			this.portLabel.Location = new System.Drawing.Point(8, 24);
			this.portLabel.Name = "portLabel";
			this.portLabel.Size = new System.Drawing.Size(88, 16);
			this.portLabel.TabIndex = 0;
			this.portLabel.Text = "Server Port";
			this.portLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tabPage1
			// 
			this.tabPage1.Location = new System.Drawing.Point(4, 21);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(296, 199);
			this.tabPage1.TabIndex = 1;
			this.tabPage1.Text = "Boards";
			// 
			// tabControl
			// 
			this.tabControl.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.mainTap,
																					 this.boardTap});
			this.tabControl.Location = new System.Drawing.Point(8, 8);
			this.tabControl.Name = "tabControl";
			this.tabControl.SelectedIndex = 0;
			this.tabControl.Size = new System.Drawing.Size(312, 224);
			this.tabControl.TabIndex = 8;
			// 
			// mainTap
			// 
			this.mainTap.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.versionLabel,
																				  this.versionBox,
																				  this.portLabel,
																				  this.portBox});
			this.mainTap.Location = new System.Drawing.Point(4, 21);
			this.mainTap.Name = "mainTap";
			this.mainTap.Size = new System.Drawing.Size(304, 199);
			this.mainTap.TabIndex = 0;
			this.mainTap.Text = "Main";
			// 
			// boardTap
			// 
			this.boardTap.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.boardGrid,
																				   this.addButton,
																				   this.editButton,
																				   this.removeButton});
			this.boardTap.Location = new System.Drawing.Point(4, 21);
			this.boardTap.Name = "boardTap";
			this.boardTap.Size = new System.Drawing.Size(304, 199);
			this.boardTap.TabIndex = 1;
			this.boardTap.Text = "Boards";
			// 
			// WinConfig
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(328, 269);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl,
																		  this.cancelButton,
																		  this.saveButton});
			this.MaximizeBox = false;
			this.Name = "WinConfig";
			this.Text = "Aicaca Config";
			((System.ComponentModel.ISupportInitialize)(this.boardGrid)).EndInit();
			this.tabControl.ResumeLayout(false);
			this.mainTap.ResumeLayout(false);
			this.boardTap.ResumeLayout(false);
			this.ResumeLayout(false);

		}
        #endregion

		private void boardGrid_Click(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			DataGrid myGrid = (DataGrid) sender;
			System.Windows.Forms.DataGrid.HitTestInfo hti = myGrid.HitTest(e.X, e.Y);

			if (hti.Type == System.Windows.Forms.DataGrid.HitTestType.Cell)
			{
			    selRow = hti.Row;
			}
		}

		private void addButton_Click(object sender, System.EventArgs e)
		{
			new WinConfigBoard(this);
		}

		private void editButton_Click(object sender, System.EventArgs e)
		{
			if (selRow != -1)
			{
				string boardName = boardGrid[selRow, 1].ToString();
				string boardType = boardGrid[selRow, 2].ToString();
				string boardPassword = boardGrid[selRow, 3].ToString();
				new WinConfigBoard(this, selRow, boardName, boardType, boardPassword);
			}
			else
			{
				MessageBox.Show(this, WC.lineStr7);
			}
		}

		private void removeButton_Click(object sender, System.EventArgs e)
		{
			if (selRow != -1)
			{
				this.RemoveBoard();
				selRow = -1;
			}
			else
			{
				MessageBox.Show(this, WC.lineStr7);
			}
		}

		private void saveButton_Click(object sender, System.EventArgs e)
		{
            this.SaveAll();
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
            this.Close();
		}

		private void ReadConfig()
		{
			xDataTable.Columns.Add("boardID");
			xDataTable.Columns.Add("boardName");
			xDataTable.Columns.Add("boardType");
			xDataTable.Columns.Add("boardPassword");

			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "ServerConfig.xml");

			portBox.Text = xd.SelectSingleNode("Config/RootID/RootPort").InnerText;
			versionBox.Text = xd.SelectSingleNode("Config/Version/ClientVersion").InnerText;
			XmlNodeList xnl = xd.SelectNodes("Config/BoardList/Board");
				
			for (IEnumerator ie = xnl.GetEnumerator() ; ie.MoveNext() ;)
			{
				XmlNode xn = ((XmlNode)ie.Current);
				string boardID = xn.SelectSingleNode("BoardID").InnerText;
				string boardName = xn.SelectSingleNode("BoardName").InnerText;
				string boardType = xn.SelectSingleNode("BoardType").InnerText;
				string boardPassword = xn.SelectSingleNode("BoardPassword").InnerText;

				DataRow dr = xDataTable.NewRow();
				dr["boardID"] = boardID;
				dr["boardName"] = boardName;
				dr["boardType"] = boardType;
				dr["boardPassword"] = boardPassword;
				xDataTable.Rows.Add(dr);
			}

			this.boardGrid.DataSource = xDataTable;
		}

		private void SaveAll()
		{
			if (this.portBox.Text.Length > 0)
			{
				this.SaveConfig();
				this.SaveBoard();

				xWinServer.StopAll();
				xWinServer.StartAll();
				this.Close();
			}
			else
			{
				MessageBox.Show(this, WC.lineStr6);
			}
		}

		private void SaveConfig()
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "ServerConfig.xml");

			XmlElement rootPort = xd.CreateElement("RootPort");
			XmlText rootPort_t = xd.CreateTextNode(this.portBox.Text);
			rootPort.AppendChild(rootPort_t);
			XmlNode rootPort_old = xd.SelectSingleNode("Config/RootID/RootPort");
			rootPort_old.ParentNode.ReplaceChild(rootPort, rootPort_old);

			XmlElement clientVersion = xd.CreateElement("ClientVersion");
			XmlText clientVersion_t = xd.CreateTextNode(this.versionBox.Text);
			clientVersion.AppendChild(clientVersion_t);
			XmlNode clientVersion_old = xd.SelectSingleNode("Config/Version/ClientVersion");
			clientVersion_old.ParentNode.ReplaceChild(clientVersion, clientVersion_old);

			xd.Save(WC.varStr1 + "ServerConfig.xml");
		}

		private void SaveBoard()
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "ServerConfig.xml");

			XmlNode xn1 = xd.SelectSingleNode("Config/BoardList");
			XmlElement xn2 = xd.CreateElement("BoardList");
			int rowCount = xDataTable.Rows.Count;

			for (int i=0 ; i < rowCount ; i++)
			{
				XmlElement board = xd.CreateElement("Board");
				XmlElement boardID = xd.CreateElement("BoardID");
				XmlElement boardName = xd.CreateElement("BoardName");
				XmlElement boardType = xd.CreateElement("BoardType");
				XmlElement boardPassword = xd.CreateElement("BoardPassword");
				XmlText boardID_t = xd.CreateTextNode(xDataTable.Rows[i][0].ToString());
				XmlText boardName_t = xd.CreateTextNode(xDataTable.Rows[i][1].ToString());
				XmlText boardType_t = xd.CreateTextNode(xDataTable.Rows[i][2].ToString());
				XmlText boardPassword_t = xd.CreateTextNode(xDataTable.Rows[i][3].ToString());
				
				xn2.AppendChild(board);
				board.AppendChild(boardID);
				board.AppendChild(boardName);
				board.AppendChild(boardType);
				board.AppendChild(boardPassword);
				boardID.AppendChild(boardID_t);
				boardName.AppendChild(boardName_t);
				boardType.AppendChild(boardType_t);
				boardPassword.AppendChild(boardPassword_t);
			}

			xn1.ParentNode.ReplaceChild(xn2, xn1);
			xd.Save(WC.varStr1 + "ServerConfig.xml");
		}

		private void RemoveBoard()
		{
			xDataTable.Rows[selRow].Delete();
			xDataTable.AcceptChanges();
		}

		public void AddBoard(string boardName, string boardPassword, string boardType)
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "ServerConfig.xml");

			XmlNode xn1 = xd.SelectSingleNode("Config/BoardID");

			int originID = Convert.ToInt32(xn1.InnerText);
			int nextID = originID + 1;

			XmlElement xn2 = xd.CreateElement("BoardID");
			XmlText xn2_t = xd.CreateTextNode(nextID.ToString());
			xn2.AppendChild(xn2_t);

			xn1.ParentNode.ReplaceChild(xn2, xn1);
			xd.Save(WC.varStr1 + "ServerConfig.xml");

			DataRow dr = xDataTable.NewRow();
			dr["boardID"] = "BBS" + originID;
			dr["boardName"] = boardName;
			dr["boardType"] = boardType;
			dr["boardPassword"] = boardPassword;
			xDataTable.Rows.Add(dr);
		}

		public void EditBoard(int boardRow, string boardName, string boardPassword, string boardType)
		{
			xDataTable.Rows[boardRow]["boardName"] = boardName;
            xDataTable.Rows[boardRow]["boardType"] = boardType;
            xDataTable.Rows[boardRow]["boardPassword"] = boardPassword;
		}
    }
}
