/*

<Aicaca Community Messenger Server>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TalkServer
{
	public class WinConfigBoard : System.Windows.Forms.Form
	{
		private WinCom WC = new WinCom();
        private WinConfig xWinConfig = null;
		private int selRow = -1;

		private System.Windows.Forms.Label nameLabel;
		private System.Windows.Forms.TextBox nameBox;
		private System.Windows.Forms.Label passwordLabel;
		private System.Windows.Forms.TextBox passwordBox;
		private System.Windows.Forms.ComboBox typeCombo;
		private System.Windows.Forms.Label typeLabel;
		private System.Windows.Forms.Button saveButton;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage mainTap;
		private System.ComponentModel.Container components = null;

		public WinConfigBoard(WinConfig tWinConfig)
		{
            xWinConfig = tWinConfig;

			InitializeComponent();
			this.ShowDialog();
		}

		public WinConfigBoard(WinConfig tWinConfig, int tSelRow, string boardName, string boardType, string boardPassword)
		{
			xWinConfig = tWinConfig;
			selRow = tSelRow;

			InitializeComponent();
            this.SetBoard(boardName, boardType, boardPassword);
			this.ShowDialog();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.nameBox = new System.Windows.Forms.TextBox();
			this.typeCombo = new System.Windows.Forms.ComboBox();
			this.nameLabel = new System.Windows.Forms.Label();
			this.typeLabel = new System.Windows.Forms.Label();
			this.passwordLabel = new System.Windows.Forms.Label();
			this.passwordBox = new System.Windows.Forms.TextBox();
			this.saveButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.tabControl = new System.Windows.Forms.TabControl();
			this.mainTap = new System.Windows.Forms.TabPage();
			this.tabControl.SuspendLayout();
			this.mainTap.SuspendLayout();
			this.SuspendLayout();
			// 
			// nameBox
			// 
			this.nameBox.Location = new System.Drawing.Point(96, 16);
			this.nameBox.MaxLength = 30;
			this.nameBox.Name = "nameBox";
			this.nameBox.Size = new System.Drawing.Size(120, 21);
			this.nameBox.TabIndex = 1;
			this.nameBox.Text = "";
			// 
			// typeCombo
			// 
			this.typeCombo.DropDownWidth = 96;
			this.typeCombo.Items.AddRange(new object[] {
														   "Common",
														   "Notice"});
			this.typeCombo.Location = new System.Drawing.Point(96, 80);
			this.typeCombo.Name = "typeCombo";
			this.typeCombo.Size = new System.Drawing.Size(120, 20);
			this.typeCombo.TabIndex = 3;
			this.typeCombo.Text = "Select Type";
			// 
			// nameLabel
			// 
			this.nameLabel.Location = new System.Drawing.Point(8, 16);
			this.nameLabel.Name = "nameLabel";
			this.nameLabel.Size = new System.Drawing.Size(80, 23);
			this.nameLabel.TabIndex = 0;
			this.nameLabel.Text = "Name";
			this.nameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// typeLabel
			// 
			this.typeLabel.Location = new System.Drawing.Point(8, 80);
			this.typeLabel.Name = "typeLabel";
			this.typeLabel.Size = new System.Drawing.Size(80, 23);
			this.typeLabel.TabIndex = 0;
			this.typeLabel.Text = "Type";
			this.typeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// passwordLabel
			// 
			this.passwordLabel.Location = new System.Drawing.Point(8, 48);
			this.passwordLabel.Name = "passwordLabel";
			this.passwordLabel.Size = new System.Drawing.Size(80, 23);
			this.passwordLabel.TabIndex = 0;
			this.passwordLabel.Text = "Password";
			this.passwordLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// passwordBox
			// 
			this.passwordBox.Location = new System.Drawing.Point(96, 48);
			this.passwordBox.MaxLength = 20;
			this.passwordBox.Name = "passwordBox";
			this.passwordBox.Size = new System.Drawing.Size(120, 21);
			this.passwordBox.TabIndex = 2;
			this.passwordBox.Text = "";
			// 
			// saveButton
			// 
			this.saveButton.Location = new System.Drawing.Point(64, 152);
			this.saveButton.Name = "saveButton";
			this.saveButton.Size = new System.Drawing.Size(88, 23);
			this.saveButton.TabIndex = 4;
			this.saveButton.Text = "Save";
			this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(160, 152);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.Size = new System.Drawing.Size(88, 23);
			this.cancelButton.TabIndex = 5;
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// tabControl
			// 
			this.tabControl.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.mainTap});
			this.tabControl.Location = new System.Drawing.Point(8, 8);
			this.tabControl.Name = "tabControl";
			this.tabControl.SelectedIndex = 0;
			this.tabControl.Size = new System.Drawing.Size(240, 136);
			this.tabControl.TabIndex = 6;
			// 
			// mainTap
			// 
			this.mainTap.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.nameLabel,
																				  this.nameBox,
																				  this.passwordLabel,
																				  this.passwordBox,
																				  this.typeLabel,
																				  this.typeCombo});
			this.mainTap.Location = new System.Drawing.Point(4, 21);
			this.mainTap.Name = "mainTap";
			this.mainTap.Size = new System.Drawing.Size(232, 111);
			this.mainTap.TabIndex = 0;
			this.mainTap.Text = "Board Properties";
			// 
			// WinConfigBoard
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(256, 181);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl,
																		  this.cancelButton,
																		  this.saveButton});
			this.MaximizeBox = false;
			this.Name = "WinConfigBoard";
			this.Text = "WinConfigBoard";
			this.tabControl.ResumeLayout(false);
			this.mainTap.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void saveButton_Click(object sender, System.EventArgs e)
		{
            string boardName = this.nameBox.Text;
			string boardPwd = this.passwordBox.Text;

			if (this.typeCombo.SelectedIndex != -1 && boardName.Length > 0 && boardPwd.Length > 0)
			{
				if (selRow == -1)
				{
					this.AddBoard();
				}
				else
				{
					this.EditBoard();
				}
			}
			else
			{
				MessageBox.Show(this, WC.lineStr8);
			}
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void SetBoard(string boardName, string boardType, string boardPassword)
		{
			if (boardType == "Common")
			{
				this.typeCombo.SelectedIndex = 0;
			}
			else if (boardType == "Notice")
			{
				this.typeCombo.SelectedIndex = 1;
			}

			this.nameBox.Text = boardName;
			this.passwordBox.Text = boardPassword;
		}

		private void AddBoard()
		{
			string boardName = this.nameBox.Text;
			string boardPassword = this.passwordBox.Text;
			string boardType = this.typeCombo.SelectedItem.ToString();
				
			xWinConfig.AddBoard(boardName, boardPassword, boardType);
			this.Close();
		}
	
		private void EditBoard()
		{
			string boardName = this.nameBox.Text;
			string boardPassword = this.passwordBox.Text;
			string boardType = this.typeCombo.SelectedItem.ToString();
				
			xWinConfig.EditBoard(selRow, boardName, boardPassword, boardType);
			this.Close();
		}
	}
}
