/*

<Aicaca Community Messenger Server>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.Xml;
using System.IO;
using System.Collections;
using System.Windows.Forms;

namespace TalkServer
{
	public class WinSearch
	{
        private WinCom WC = new WinCom();

        private static int preLen = 10;
		private static int posLen = 13;
		private static int indexCount = 30;

		public string SaveProcess(string sort, string msg)
		{
			string str = this.SaveFile(sort, msg);
			this.SaveIndex(sort, str, msg + "\n");
			return str;
		}

		public void DeleteProcess(string sort, int pos)
		{   
			string str = this.GetMsg(sort, pos);
			this.DeleteIndex(sort, pos.ToString(), str + "\n");
		}

		public ArrayList SearchProcess(string sort, string keyword)
		{
			ArrayList list = this.StartSearch(sort, keyword.ToUpper());
			return list;
		}

		public string GetMsg(string sort, int pos)
		{
			char[] lenBuffer = new char[preLen];

			FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Source.dat", FileMode.Open, FileAccess.Read);
			StreamReader sr = new StreamReader(fs);
			sr.BaseStream.Seek(pos, SeekOrigin.Begin);
			sr.Read(lenBuffer, 0, preLen);
			sr.Close();

            int len = Convert.ToInt32(new String(lenBuffer));
			char[] msgBuffer = new char[len];

            FileStream ft = new FileStream(WC.varStr1 + "Data\\" + sort + "_Source.dat", FileMode.Open, FileAccess.Read);
			StreamReader st = new StreamReader(ft);
			st.BaseStream.Seek(pos+preLen, SeekOrigin.Begin);
			st.Read(msgBuffer, 0, len);
			st.Close();
			
			string str = new String(msgBuffer);
			return str;
		}

		private string SaveFile(string sort, string msg)
		{
            char[] msgBuffer = msg.ToCharArray();
			int len = msgBuffer.Length;
			char[] lenBuffer = len.ToString().ToCharArray();
			char[] nullBuffer = new char[preLen-lenBuffer.Length];

			FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Source.dat", FileMode.Open, FileAccess.Write);
			string pos = fs.Length.ToString();
			StreamWriter sw = new StreamWriter(fs);
			sw.BaseStream.Seek(0, SeekOrigin.End);
			sw.Write(lenBuffer, 0, lenBuffer.Length);
			sw.Write(nullBuffer, 0, nullBuffer.Length);
			sw.Write(msgBuffer, 0, len);
			sw.Flush();
			sw.Close();

			return pos;
		}

		private void SaveIndex(string sort, string idStr, string originStr)
		{
			
			char[] buffer = originStr.ToCharArray();
			string str = "";
			ArrayList list = new ArrayList();

			for (int i=0 ; i < buffer.Length ; i++)
			{
				int var = Convert.ToInt32(buffer.GetValue(i));
				
				if ((var >= 65 && var <= 90) || (var >= 97 && var <= 122) || (var >= 44032 && var <= 55203))
				{
					str += Convert.ToString(Convert.ToChar(var));
				}
				else
				{
					if (str.Length > 0)
					{
						str = str.ToUpper();
						if (!list.Contains(str)) list.Add(str);
						str = "";
					}
					else
					{
						str = "";
					}
				}
			}

			this.SaveAddress(sort, idStr, list);
		}

		private void SaveAddress(string sort, string idStr, ArrayList list)
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "Data\\" + sort + "_Index.xml");

			for (IEnumerator ie = list.GetEnumerator() ; ie.MoveNext() ;)
			{
				string str = (string)ie.Current;

				XmlNode xn = xd.SelectSingleNode("Index/RD[ID='" + str + "']");

				if (xn == null)
				{
					XmlNode xn1 = xd.SelectSingleNode("Index/PO");
					int PO1 = Convert.ToInt32(xn1.InnerText);
					int PO2 = PO1 + (posLen*indexCount);

					XmlElement xn2 = xd.CreateElement("PO");
					XmlText xn2_t = xd.CreateTextNode(PO2.ToString());
					xn2.AppendChild(xn2_t);
					xn1.ParentNode.ReplaceChild(xn2, xn1);

					XmlElement record = xd.CreateElement("RD");
					XmlElement id = xd.CreateElement("ID");
					XmlElement pos = xd.CreateElement("PO");
					XmlElement count = xd.CreateElement("CO");

					XmlText id_t = xd.CreateTextNode(str);
					XmlText pos_t = xd.CreateTextNode(PO1.ToString());
					XmlText count_t = xd.CreateTextNode("1");
			
					xd.DocumentElement.AppendChild(record);
					record.AppendChild(id);
					record.AppendChild(pos);
					record.AppendChild(count);
					id.AppendChild(id_t);
					pos.AppendChild(pos_t);
					count.AppendChild(count_t);

					this.MakeSpace(sort, idStr);
				}
				else
				{
					int PO = Convert.ToInt32(xn.SelectSingleNode("PO").InnerText);

					XmlNode xn1 = xn.SelectSingleNode("CO");
					int CO1 = Convert.ToInt32(xn1.InnerText);
					int CO2 = CO1 + 1;

					XmlElement xn2 = xd.CreateElement("CO");
					XmlText xn2_t = xd.CreateTextNode(CO2.ToString());
					xn2.AppendChild(xn2_t);
					xn1.ParentNode.ReplaceChild(xn2, xn1);

					this.AddSpace(sort, idStr, PO, CO1);
				}
			}

			xd.Save(WC.varStr1 + "Data\\" + sort + "_Index.xml");
		}

		private void MakeSpace(string sort, string idStr)
		{
			char[] buffer = new char[posLen*indexCount];
			char[] name = idStr.ToCharArray();

			for (int i=0 ; i < name.Length ; i++)
			{
				buffer[i] = name[i];
			}

			FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Address.dat", FileMode.Open, FileAccess.Write);
			StreamWriter sw = new StreamWriter(fs);
			sw.BaseStream.Seek(0, SeekOrigin.End);
			sw.Write(buffer);
			sw.Flush();
			sw.Close();
		}

		private void AddSpace(string sort, string idStr, int pos, int count)
		{
			char[] buffer = new char[posLen*indexCount];
			char[] name = idStr.ToCharArray();
            
			if (count >= indexCount)
			{
				count = count % indexCount;
			}

			FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Address.dat", FileMode.Open, FileAccess.Read);
			StreamReader sr = new StreamReader(fs);
			sr.BaseStream.Seek(pos, SeekOrigin.Begin);
			sr.Read(buffer, 0, posLen*indexCount);
			sr.Close();

			for (int i=0 ; i < name.Length ; i++)
			{
				buffer[count*posLen + i] = name[i];
			}

			FileStream ft = new FileStream(WC.varStr1 + "Data\\" + sort + "_Address.dat", FileMode.Open, FileAccess.Write);
			StreamWriter sw = new StreamWriter(ft);
			sw.BaseStream.Seek(pos, SeekOrigin.Begin);
			sw.Write(buffer, 0, posLen*indexCount);
			sw.Flush();
			sw.Close();
		}

		private void DeleteIndex(string sort, string idStr, string originStr)
		{
			
			char[] buffer = originStr.ToCharArray();
			string str = "";
			ArrayList list = new ArrayList();

			for (int i=0 ; i < buffer.Length ; i++)
			{
				int var = Convert.ToInt32(buffer.GetValue(i));
				
				if ((var >= 65 && var <= 90) || (var >= 97 && var <= 122) || (var >= 44032 && var <= 55203))
				{
					str += Convert.ToString(Convert.ToChar(var));
				}
				else
				{
					if (str.Length > 0)
					{
						str = str.ToUpper();
						if (!list.Contains(str)) list.Add(str);
						str = "";
					}
					else
					{
						str = "";
					}
				}
			}

			this.DeleteAddress(sort, idStr, list);
		}

		private void DeleteAddress(string sort, string idStr, ArrayList list)
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "Data\\" + sort + "_Index.xml");

			for (IEnumerator ie = list.GetEnumerator() ; ie.MoveNext() ;)
			{
				string str = (string)ie.Current;

				XmlNode xn = xd.SelectSingleNode("Index/RD[ID='" + str + "']");

				int PO = Convert.ToInt32(xn.SelectSingleNode("PO").InnerText);

				XmlNode xn1 = xn.SelectSingleNode("CO");
				int CO1 = Convert.ToInt32(xn1.InnerText);
				int CO2 = CO1 - 1;

				XmlElement xn2 = xd.CreateElement("CO");
				XmlText xn2_t = xd.CreateTextNode(CO2.ToString());
				xn2.AppendChild(xn2_t);
				xn1.ParentNode.ReplaceChild(xn2, xn1);

				this.DeleteSpace(sort, idStr, PO, CO1);
			}

			xd.Save(WC.varStr1 + "Data\\" + sort + "_Index.xml");
		}

		private void DeleteSpace(string sort, string idStr, int pos, int count)
		{
			char[] buffer = new char[posLen*indexCount];
			char[] next = new char[posLen*indexCount];
			char[] name = idStr.ToCharArray();
			int len = name.Length;
			int num = 0;

			if (count > indexCount)
			{
				count = indexCount;
			}
            
			FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Address.dat", FileMode.Open, FileAccess.Read);
			StreamReader sr = new StreamReader(fs);
			sr.BaseStream.Seek(pos, SeekOrigin.Begin);
			sr.Read(buffer, 0, posLen*indexCount);
			sr.Close();

			for (int i=0 ; i < count ; i++)
			{
				char[] temp = new char[len];

				for (int j=0 ; j < len ; j++)
				{
					temp[j] = buffer[i*posLen + j];
				}

				if (new String(temp) == new String(name))
				{
					num = i*posLen;
					break;
				}
			}

			for (int i=0 ; i < posLen*(indexCount-1) ; i++)
			{
				if (i >= num)
				{
					next[i] = buffer[i+posLen];
				}
				else
				{
					next[i] = buffer[i];
				}
			}

			FileStream ft = new FileStream(WC.varStr1 + "Data\\" + sort + "_Address.dat", FileMode.Open, FileAccess.Write);
			StreamWriter sw = new StreamWriter(ft);
			sw.BaseStream.Seek(pos, SeekOrigin.Begin);
			sw.Write(next, 0, posLen*indexCount);
			sw.Flush();
			sw.Close();
		}

		private ArrayList StartSearch(string sort, string keyword)
		{
            ArrayList list = new ArrayList();

			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "Data\\" + sort + "_Index.xml"); 
			XmlNodeList xnl = xd.SelectNodes("Index/RD[contains(ID,'" + keyword.ToUpper() + "')]");
			
			if (xnl.Count > 0)
			{
				for (IEnumerator ie = xnl.GetEnumerator() ; ie.MoveNext() ;)
				{
					XmlNode xn = ((XmlNode)ie.Current);
					int pos = Convert.ToInt32(xn.SelectSingleNode("PO").InnerText);
					int count = Convert.ToInt32(xn.SelectSingleNode("CO").InnerText);
					if (count > indexCount) count = indexCount;
					char[] buffer = new char[posLen*indexCount];
					char[] addr = new char[posLen];

					FileStream fs = new FileStream(WC.varStr1 + "Data\\" + sort + "_Address.dat", FileMode.Open, FileAccess.Read);
					StreamReader sr = new StreamReader(fs);
					sr.BaseStream.Seek(pos, SeekOrigin.Begin);
					sr.Read(buffer, 0, posLen*indexCount);
					sr.Close();

					for (int i=0 ; i < count ; i++)
					{
						for (int j=0 ; j < posLen ; j++)
						{
							addr[j] = buffer[i*posLen + j];
						}

						try
						{
							int var = Convert.ToInt32(new String(addr));
							if (!list.Contains(var)) list.Add(var);
						}
						catch(Exception e)
						{
						}
					}
				}

				list.Sort();
			}
			
			return list;
		}
	}
}
