/*

<Aicaca Community Messenger Server>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.IO;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.Xml;

namespace TalkServer
{
	public class WinServer : System.Windows.Forms.Form
	{
		private WinCom WC = new WinCom();
		private WinAccept xWinAccept = null;

		private Hashtable ClientHash = new Hashtable();
		private string rootID ;
		private string clientAddr;
		private string configData;

		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.NotifyIcon onTrayIcon;
		private System.Windows.Forms.NotifyIcon offTrayIcon;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem actionMenu;
		private System.Windows.Forms.MenuItem configMenu;
		private System.Windows.Forms.MenuItem startMenu;
		private System.Windows.Forms.MenuItem stopMenu;
		private System.Windows.Forms.MenuItem hideMenu;
		private System.Windows.Forms.MenuItem shutMenu;
		private System.Windows.Forms.MenuItem helpMenu;
		private System.Windows.Forms.MenuItem aboutMenu;
		private System.Windows.Forms.ToolBarButton configBtn;
		private System.Windows.Forms.ToolBarButton startBtn;
		private System.Windows.Forms.ToolBarButton stopBtn;
		private System.Windows.Forms.ToolBarButton hideBtn;
		private System.Windows.Forms.ToolBarButton shutBtn;
		private System.Windows.Forms.ToolBar toolBar;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.StatusBarPanel mainStatus;
		private System.Windows.Forms.StatusBarPanel processStatus;
		private System.Windows.Forms.ListView clientList;
		private System.Windows.Forms.ColumnHeader idColumn;
		private System.Windows.Forms.ColumnHeader ipColumn;
		private System.Windows.Forms.ListView boardList;
		private System.Windows.Forms.ColumnHeader nameColumn;
		private System.Windows.Forms.ColumnHeader typeColumn;
		private System.Windows.Forms.TextBox chatBox;
		private System.Windows.Forms.ColumnHeader portColumn;

		public WinServer()
		{
			try
			{
				this.InitializeComponent();
				this.InitializeServer();
			}
			catch (Exception e)
			{
				MessageBox.Show(e.ToString());
			}
		}

		protected override void Dispose(bool disposing)
		{
			this.Visible = false;
		}

        #region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(WinServer));
			this.onTrayIcon = new System.Windows.Forms.NotifyIcon(this.components);
			this.offTrayIcon = new System.Windows.Forms.NotifyIcon(this.components);
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.mainStatus = new System.Windows.Forms.StatusBarPanel();
			this.processStatus = new System.Windows.Forms.StatusBarPanel();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.actionMenu = new System.Windows.Forms.MenuItem();
			this.configMenu = new System.Windows.Forms.MenuItem();
			this.startMenu = new System.Windows.Forms.MenuItem();
			this.stopMenu = new System.Windows.Forms.MenuItem();
			this.hideMenu = new System.Windows.Forms.MenuItem();
			this.shutMenu = new System.Windows.Forms.MenuItem();
			this.helpMenu = new System.Windows.Forms.MenuItem();
			this.aboutMenu = new System.Windows.Forms.MenuItem();
			this.toolBar = new System.Windows.Forms.ToolBar();
			this.configBtn = new System.Windows.Forms.ToolBarButton();
			this.startBtn = new System.Windows.Forms.ToolBarButton();
			this.stopBtn = new System.Windows.Forms.ToolBarButton();
			this.hideBtn = new System.Windows.Forms.ToolBarButton();
			this.shutBtn = new System.Windows.Forms.ToolBarButton();
			this.clientList = new System.Windows.Forms.ListView();
			this.idColumn = new System.Windows.Forms.ColumnHeader();
			this.ipColumn = new System.Windows.Forms.ColumnHeader();
			this.portColumn = new System.Windows.Forms.ColumnHeader();
			this.boardList = new System.Windows.Forms.ListView();
			this.nameColumn = new System.Windows.Forms.ColumnHeader();
			this.typeColumn = new System.Windows.Forms.ColumnHeader();
			this.chatBox = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.mainStatus)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.processStatus)).BeginInit();
			this.SuspendLayout();
			// 
			// onTrayIcon
			// 
			this.onTrayIcon.Icon = ((System.Drawing.Icon)(resources.GetObject("onTrayIcon.Icon")));
			this.onTrayIcon.Text = "Connected";
			this.onTrayIcon.Visible = true;
			this.onTrayIcon.DoubleClick += new System.EventHandler(this.TrayIcon_DoubleClick);
			// 
			// offTrayIcon
			// 
			this.offTrayIcon.Icon = ((System.Drawing.Icon)(resources.GetObject("offTrayIcon.Icon")));
			this.offTrayIcon.Text = "Disconnected";
			this.offTrayIcon.DoubleClick += new System.EventHandler(this.TrayIcon_DoubleClick);
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 328);
			this.statusBar.Name = "statusBar";
			this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						 this.mainStatus,
																						 this.processStatus});
			this.statusBar.ShowPanels = true;
			this.statusBar.Size = new System.Drawing.Size(600, 22);
			this.statusBar.TabIndex = 0;
			// 
			// mainStatus
			// 
			this.mainStatus.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.mainStatus.Width = 384;
			// 
			// processStatus
			// 
			this.processStatus.Width = 200;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.actionMenu,
																					 this.helpMenu});
			// 
			// actionMenu
			// 
			this.actionMenu.Index = 0;
			this.actionMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.configMenu,
																					   this.startMenu,
																					   this.stopMenu,
																					   this.hideMenu,
																					   this.shutMenu});
			this.actionMenu.Text = "Action";
			// 
			// configMenu
			// 
			this.configMenu.Index = 0;
			this.configMenu.Text = "Config";
			this.configMenu.Click += new System.EventHandler(this.configMenu_Click);
			// 
			// startMenu
			// 
			this.startMenu.Enabled = false;
			this.startMenu.Index = 1;
			this.startMenu.Text = "Server Start";
			this.startMenu.Click += new System.EventHandler(this.startMenu_Click);
			// 
			// stopMenu
			// 
			this.stopMenu.Index = 2;
			this.stopMenu.Text = "Server Stop";
			this.stopMenu.Click += new System.EventHandler(this.stopMenu_Click);
			// 
			// hideMenu
			// 
			this.hideMenu.Index = 3;
			this.hideMenu.Text = "Hide";
			this.hideMenu.Click += new System.EventHandler(this.hideMenu_Click);
			// 
			// shutMenu
			// 
			this.shutMenu.Index = 4;
			this.shutMenu.Text = "Shut Down";
			this.shutMenu.Click += new System.EventHandler(this.shutMenu_Click);
			// 
			// helpMenu
			// 
			this.helpMenu.Index = 1;
			this.helpMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.aboutMenu});
			this.helpMenu.Text = "Help";
			// 
			// aboutMenu
			// 
			this.aboutMenu.Index = 0;
			this.aboutMenu.Text = "About Aicaca Server";
			this.aboutMenu.Click += new System.EventHandler(this.aboutMenu_Click);
			// 
			// toolBar
			// 
			this.toolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.configBtn,
																					   this.startBtn,
																					   this.stopBtn,
																					   this.hideBtn,
																					   this.shutBtn});
			this.toolBar.ButtonSize = new System.Drawing.Size(80, 35);
			this.toolBar.DropDownArrows = true;
			this.toolBar.Name = "toolBar";
			this.toolBar.ShowToolTips = true;
			this.toolBar.Size = new System.Drawing.Size(600, 38);
			this.toolBar.TabIndex = 1;
			this.toolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_ButtonClick);
			// 
			// configBtn
			// 
			this.configBtn.Text = "Config";
			// 
			// startBtn
			// 
			this.startBtn.Enabled = false;
			this.startBtn.Text = "Server Start";
			// 
			// stopBtn
			// 
			this.stopBtn.Text = "Server Stop";
			// 
			// hideBtn
			// 
			this.hideBtn.Text = "Hide";
			// 
			// shutBtn
			// 
			this.shutBtn.Text = "Shut Down";
			// 
			// clientList
			// 
			this.clientList.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.clientList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.idColumn,
																						 this.ipColumn,
																						 this.portColumn});
			this.clientList.Location = new System.Drawing.Point(0, 40);
			this.clientList.Name = "clientList";
			this.clientList.Size = new System.Drawing.Size(254, 144);
			this.clientList.TabIndex = 2;
			this.clientList.View = System.Windows.Forms.View.Details;
			// 
			// idColumn
			// 
			this.idColumn.Text = "User ID";
			this.idColumn.Width = 80;
			// 
			// ipColumn
			// 
			this.ipColumn.Text = "IP";
			this.ipColumn.Width = 120;
			// 
			// portColumn
			// 
			this.portColumn.Text = "Port";
			this.portColumn.Width = 50;
			// 
			// boardList
			// 
			this.boardList.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.boardList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.nameColumn,
																						this.typeColumn});
			this.boardList.Location = new System.Drawing.Point(0, 184);
			this.boardList.Name = "boardList";
			this.boardList.Size = new System.Drawing.Size(254, 144);
			this.boardList.TabIndex = 3;
			this.boardList.View = System.Windows.Forms.View.Details;
			// 
			// nameColumn
			// 
			this.nameColumn.Text = "Board Name";
			this.nameColumn.Width = 150;
			// 
			// typeColumn
			// 
			this.typeColumn.Text = "Board Type";
			this.typeColumn.Width = 100;
			// 
			// chatBox
			// 
			this.chatBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.chatBox.Location = new System.Drawing.Point(256, 40);
			this.chatBox.Multiline = true;
			this.chatBox.Name = "chatBox";
			this.chatBox.ReadOnly = true;
			this.chatBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.chatBox.Size = new System.Drawing.Size(344, 288);
			this.chatBox.TabIndex = 0;
			this.chatBox.Text = "";
			// 
			// WinServer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(600, 350);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chatBox,
																		  this.boardList,
																		  this.clientList,
																		  this.toolBar,
																		  this.statusBar});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "WinServer";
			this.Text = "Aicaca Server";
			((System.ComponentModel.ISupportInitialize)(this.mainStatus)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.processStatus)).EndInit();
			this.ResumeLayout(false);

		}
        #endregion

		private void configMenu_Click(object sender, System.EventArgs e)
		{
		    this.StartWinConfig();
		}

		private void hideMenu_Click(object sender, System.EventArgs e)
		{
		    this.Visible = false;
		}

		private void startMenu_Click(object sender, System.EventArgs e)
		{
		    this.StartAll();
		}

		private void stopMenu_Click(object sender, System.EventArgs e)
		{
		    this.StopAll();
		}

		private void shutMenu_Click(object sender, System.EventArgs e)
		{
			this.ShutDown();
		}

		private void aboutMenu_Click(object sender, System.EventArgs e)
		{
		    System.Diagnostics.Process.Start("IEXPLORE.EXE", "www.aicaca.com");
		}

		private void toolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
		    string str = e.Button.Text;

			switch(str)
			{
				case "Config":
					this.StartWinConfig();
					break;
				case "Server Start":
					this.StartAll();
					break;
				case "Server Stop":
					this.StopAll();
					break;
				case "Hide":
					this.Visible = false;
					break;
				case "Shut Down":
					this.ShutDown();
					break;
			}
		}

		private void TrayIcon_DoubleClick (object sender, System.EventArgs e)
		{
			this.Visible = true;
		}

		private void ShutDown()
		{
			if (xWinAccept != null) this.xWinAccept.CloseThis();
			this.CloseAllClient();

			if (onTrayIcon != null) onTrayIcon.Dispose();
			if (offTrayIcon != null) offTrayIcon.Dispose();

			if (components != null) 
			{
				components.Dispose();
			}
			
			base.Dispose(true);
		}

		private void CloseAllClient()
		{
			for (IEnumerator ie = ClientHash.Values.GetEnumerator() ; ie.MoveNext() ;)
			{
				((WinDialog)ie.Current).CloseThis();
			}
		}

		private void InitializeServer()
		{
			DirectoryInfo xDirInfo = new DirectoryInfo(WC.varStr1 + "Upload");
			if (!xDirInfo.Exists) xDirInfo.Create();

			DirectoryInfo yDirInfo = new DirectoryInfo(WC.varStr1 + "Data");
			if (!yDirInfo.Exists) yDirInfo.Create();

			DirectoryInfo zDirInfo = new DirectoryInfo(WC.varStr1 + "Download");
			if (!zDirInfo.Exists) zDirInfo.Create();

			if (System.IO.File.Exists(WC.varStr1 + "ServerConfig.xml") == false)
			{
				XmlTextWriter xw = new XmlTextWriter(WC.varStr1 + "ServerConfig.xml", null);

				xw.WriteStartElement("Config");
				xw.WriteStartElement("RootID");
				xw.WriteElementString("RootSort", "WinServer");
				xw.WriteElementString("RootName", "Root");
				xw.WriteElementString("RootPort", "80");
				xw.WriteEndElement();
				xw.WriteStartElement("Version");
				xw.WriteElementString("ServerVersion", "Ver1.2");
				xw.WriteElementString("ClientVersion", "Ver1.2");
				xw.WriteEndElement();
				xw.WriteStartElement("BoardList");
				xw.WriteEndElement();
				xw.WriteElementString("BoardID", "1");
				xw.WriteEndElement();
				xw.Flush();
				xw.Close();
			}
            
			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "ServerConfig.xml");

			string rootSort = xd.SelectSingleNode("Config/RootID/RootSort").InnerText;
			string rootName = xd.SelectSingleNode("Config/RootID/RootName").InnerText;
			string rootIP = Dns.GetHostByName(Dns.GetHostName()).AddressList[0].ToString();
			string rootPort = xd.SelectSingleNode("Config/RootID/RootPort").InnerText;
			rootID = WC.MakeRootID(rootSort, rootName, rootIP, rootPort);
				
			string versionInfo = xd.SelectSingleNode("Config/Version").OuterXml;
			string boardList = xd.SelectSingleNode("Config/BoardList").OuterXml;
			configData = "<Config>" + versionInfo + boardList + "</Config>";

			this.InsertBoardList();
			this.StartWinAccept();
		}

		private void InsertClientAddr()
		{
			int firstPos = -1;
			this.clientList.Items.Clear();

			while ((firstPos = clientAddr.IndexOf("<cid>", firstPos+1)) != -1)
			{
				string[] strs = new string[3];
				strs[0] = WC.GetXML(clientAddr, "cn", firstPos);
				strs[1] = WC.GetXML(clientAddr, "ci", firstPos);
				strs[2] = WC.GetXML(clientAddr, "cp", firstPos);

				this.clientList.Items.Add(new ListViewItem(strs));
			}
		}

		private void InsertBoardList()
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(new XmlTextReader(new StringReader(configData)));
			XmlNodeList xnl = xd.SelectNodes("Config/BoardList/Board");
				
			for (IEnumerator ie = xnl.GetEnumerator() ; ie.MoveNext() ;)
			{
				XmlNode xn = ((XmlNode)ie.Current);
				string[] strs = new string[2];
				strs[0] = xn.SelectSingleNode("BoardName").InnerText;
				strs[1] = xn.SelectSingleNode("BoardType").InnerText;

				this.boardList.Items.Add(new ListViewItem(strs));
			}
		}

		private void AddThread(object o, string clientID, string threadID)
		{
			ClientHash.Add(threadID, o);
			clientAddr += clientID;
			this.InsertClientAddr();
		}

		private void RemoveThread(string clientID, string threadID)
		{
			ClientHash.Remove(threadID);
			clientAddr = WC.RemoveStr(clientAddr, clientID);
			this.InsertClientAddr();
		}

		private void SendConfigData(string threadID)
		{
			((WinDialog)ClientHash[threadID]).SendConfigData(configData);
		}

		private void SendClientAddr()
		{
			for (IEnumerator ie = ClientHash.Values.GetEnumerator() ; ie.MoveNext() ;)
			{
				((WinDialog)ie.Current).SendClientAddr(clientAddr);
			}
		}

		private void AddLog(string str, string statusStr)
		{
			string logFile = WC.varStr1 + "Log.log";
			string clientName = WC.GetXML(str, "cn");
			string clientIP = WC.GetXML(str, "ci");
			string clientPort = WC.GetXML(str, "cp");
			string timeStr = DateTime.Now.ToLongDateString() + "  " + DateTime.Now.ToLongTimeString();

			FileStream fs = new  FileStream(logFile, FileMode.OpenOrCreate, FileAccess.Write);
			StreamWriter sw = new StreamWriter(fs);
			sw.BaseStream.Seek(0, SeekOrigin.End);  
			sw.Write("{0}:{1}:{2}  {3}  {4}", timeStr, clientName, clientIP, clientPort, statusStr + "\r\n");
			sw.Flush();
			sw.Close();
		}

		private void AddSession()
		{
			string sessionFile = WC.varStr1 + "ServerSession.xml";

			StreamWriter w = System.IO.File.CreateText(sessionFile);
			w.WriteLine(clientAddr);
			w.Close();
		}

		private void AddChatText(string name, string str)
		{
			str = WC.ReplaceStr(str, "&Line;", "\n");
            this.chatBox.Text = "[" + name + "]\r\n" + str + "\r\n\r\n";
		}

		private void StartWinConfig()
		{
			new WinConfig(this);
		}

		private void StartWinAccept()
		{
			xWinAccept = new WinAccept(this, rootID);
			Thread ServerThread = new Thread(new ThreadStart(xWinAccept.ServerProc));
			ServerThread.Start();
		}

		public void StartAll()
		{
			this.InitializeServer();

			this.startMenu.Enabled = false;
			this.startBtn.Enabled = false;
			this.stopMenu.Enabled = true;
			this.stopBtn.Enabled = true;

			onTrayIcon.Visible = true;
			offTrayIcon.Visible = false;
		}

		public void StopAll()
		{
			if (xWinAccept != null) this.xWinAccept.CloseThis();
			this.CloseAllClient();

			this.startMenu.Enabled = true;
            this.startBtn.Enabled = true;
			this.stopMenu.Enabled = false;
			this.stopBtn.Enabled = false;

			onTrayIcon.Visible = false;
			offTrayIcon.Visible = true;

			clientList.Items.Clear();
			boardList.Items.Clear();
			clientAddr = "";
			configData = "";
			this.chatBox.Text = "";
		}

		public void AddClient(WinDialog w, string clientID, string threadID)
		{
			lock(this)
			{
				this.AddThread(w, clientID, threadID);
				this.AddLog(clientID, "Connected");
				this.AddSession();
				this.SendConfigData(threadID);
				this.SendClientAddr();
			}
		}

		public void RemoveClient(string clientID, string threadID)
		{
			lock(this)
			{
				this.RemoveThread(clientID, threadID);
				this.AddLog(clientID, "Disconnected");
				this.AddSession();
				this.SendClientAddr();
			}
		}

		public void SendRoundMsg(string roundID, string str)
		{
			lock(this)
			{
				((WinDialog)ClientHash[roundID]).SendMsg(str);
			}
		}

		public void SendRoundChat(string str)
		{
			lock(this)
			{
				for (IEnumerator ie = ClientHash.Values.GetEnumerator() ; ie.MoveNext() ;)
				{
					((WinDialog)ie.Current).SendChat(str);
				}

				this.AddChatText(WC.GetXML(str, "ln"), WC.GetNextXML(str, "body"));
			}
		}

		public void SendRoundFile(string roundID, string str, byte[] b)
		{
			lock(this)
			{
				((WinDialog)ClientHash[roundID]).SendMsg(str);
				((WinDialog)ClientHash[roundID]).SendStream(b);
			}
		}

		public string pMainStatus
		{
			set
			{
				this.statusBar.Panels[0].Text = value;
			}
		}

		public string pProcessStatus
		{
			set
			{
				this.statusBar.Panels[1].Text = value;
			}
		}

		public static void Main(string[] args) 
		{
			Application.Run(new WinServer());
		}
	}
}